| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
cutlass::MatrixCoord Struct Reference

`#include <matrix_coord.h>`

Inheritance diagram for cutlass::MatrixCoord:
[legend]
Collaboration diagram for cutlass::MatrixCoord:
[legend]

## Public Types
using | Index = int
| Integer-valued index. More...
using | Base = Coord< 2, Index >
| Base type is a Coord of rank=2. More...
Public Types inherited from cutlass::Coord< 2, int >
using | Index = int
| Index type used to store elements. More...
using | LongIndex = int64_t
| Type used to represent linear offsets. More...

## Public Member Functions
CUTLASS_HOST_DEVICE | MatrixCoord ()
| Default ctor. More...
CUTLASS_HOST_DEVICE | MatrixCoord (Coord< 2, Index > const &coord)
| Constructs from Coord<2> More...
CUTLASS_HOST_DEVICE | MatrixCoord (Index row, Index column)
| Helper to construct from a row and column. More...
CUTLASS_HOST_DEVICE Index const & | row () const
| Returns the row of the coordinate. More...
CUTLASS_HOST_DEVICE Index & | row ()
| Returns the row of the coordinate. More...
CUTLASS_HOST_DEVICE Index const & | column () const
| Returns the column of the coordinate. More...
CUTLASS_HOST_DEVICE Index & | column ()
| Returns the column of the coordinate. More...
CUTLASS_HOST_DEVICE MatrixCoord | operator+ (Base const &b) const
| Element-wise addition. More...
CUTLASS_HOST_DEVICE MatrixCoord | operator- (Base const &b) const
| Element-wise subtraction. More...
CUTLASS_HOST_DEVICE MatrixCoord | operator* (Base const &b) const
| Element-wise multiplication. More...
CUTLASS_HOST_DEVICE MatrixCoord | operator/ (Base const &b) const
| Element-wise division. More...
CUTLASS_HOST_DEVICE MatrixCoord & | operator+= (Base const &b)
| In-place addition. More...
CUTLASS_HOST_DEVICE MatrixCoord & | operator-= (Base const &b)
| In-place subtraction. More...
CUTLASS_HOST_DEVICE MatrixCoord & | operator*= (Base const &b)
| In-place multiplication. More...
CUTLASS_HOST_DEVICE MatrixCoord & | operator/= (Base const &b)
| In-place division. More...
Public Member Functions inherited from cutlass::Coord< 2, int >
CUTLASS_HOST_DEVICE | Coord (Index value=Index(0))
| Default ctor initializes uniformly. More...
CUTLASS_HOST_DEVICE | Coord (Index const (&_idx)[kRank])
| Constructs from an array of integers. More...
CUTLASS_HOST_DEVICE | Coord (Coord< kRank, Index, LongIndex > const &coord)
| Copy constructor. More...
CUTLASS_HOST_DEVICE Coord< Slice > | slice (int start=0, Index identity=0) const
CUTLASS_HOST_DEVICE int | min_dim_index () const
| Returns the index of the dimension with least value. More...
CUTLASS_HOST_DEVICE int | max_dim_index () const
| Returns the index of the dimension with greatest value. More...
CUTLASS_HOST_DEVICE | operator bool () const
| Returns true if Coord is non-zero. More...
CUTLASS_HOST_DEVICE bool | operator! () const
| Returns true if Coord is uniformly zero. More...
CUTLASS_HOST_DEVICE Coord | operator+ (Coord const &b) const
| Element-wise addition. More...
CUTLASS_HOST_DEVICE Coord | operator- (Coord const &b) const
| Element-wise subtraction. More...
CUTLASS_HOST_DEVICE Coord | operator* (Coord const &b) const
| Element-wise multiplication. More...
CUTLASS_HOST_DEVICE Coord | operator/ (Coord const &b) const
| Element-wise division. More...
CUTLASS_HOST_DEVICE Coord & | operator+= (Coord const &b)
| In-place addition. More...
CUTLASS_HOST_DEVICE Coord & | operator-= (Coord const &b)
| In-place subtraction. More...
CUTLASS_HOST_DEVICE Coord & | operator*= (Coord const &b)
| In-place multiplication. More...
CUTLASS_HOST_DEVICE Coord & | operator/= (Coord const &b)
| In-place division. More...
CUTLASS_HOST_DEVICE Index & | operator[] (int dim)
| Member access operator. More...
CUTLASS_HOST_DEVICE Index const & | operator[] (int dim) const
| Member access operator. More...
CUTLASS_HOST_DEVICE LongIndex | dot (Coord const &b, LongIndex sum=LongIndex(0)) const
| Computes the dot product with anotherCoord object. More...
CUTLASS_HOST_DEVICE Index & | at ()
| Gets the index of a given Coord element. More...
CUTLASS_HOST_DEVICE Index & | at (int dim)
| Access via index; may limit unrolling potential. More...
CUTLASS_HOST_DEVICE Index const & | at () const
| Gets the index of a given Coord element. More...
CUTLASS_HOST_DEVICE Index const & | at (int dim) const
| Access via index; may limit unrolling potential. More...
CUTLASS_HOST_DEVICE bool | operator== (Coord const &b) const
| Determines if two Coord<> objects are equal. More...
CUTLASS_HOST_DEVICE bool | operator!= (Coord const &b) const
| Not equal. More...
CUTLASS_HOST_DEVICE Coord & | clamp (Coord const &max, Coord const &min=Coord())
| Clamps a coordinate to a range specified by maximum and minimum values. More...
CUTLASS_HOST_DEVICE Index | sum () const
| Returns the sum of all elements. More...
CUTLASS_HOST_DEVICE LongIndex | product () const
| Returns the product of all elements. More...
CUTLASS_HOST_DEVICE bool | operator< (Coord const &b) const
| Less than operator. More...
CUTLASS_HOST_DEVICE bool | operator<= (Coord const &b) const
| Less than or equals operator. More...
CUTLASS_HOST_DEVICE bool | operator> (Coord const &b) const
| Greater than operator. More...
CUTLASS_HOST_DEVICE bool | operator>= (Coord const &b) const
| Greater than or equals operator. More...

## Additional Inherited Members
Static Public Attributes inherited from cutlass::Coord< 2, int >
static int const | kRank
| Number of elements in Coord. More...

## Detailed Description

MatrixCoord wraps Coord<2, int> to provide a helper for accessing named dimensions. Classes expecting a coordinate in the rank=2 index space of a matrix should use MatrixCoord.

## Member Typedef Documentation

using cutlass::MatrixCoord::Base = Coord<2, Index>

using cutlass::MatrixCoord::Index = int

## Constructor & Destructor Documentation

CUTLASS_HOST_DEVICE cutlass::MatrixCoord::MatrixCoord | ( |  | ) |
| inline

CUTLASS_HOST_DEVICE cutlass::MatrixCoord::MatrixCoord | ( | Coord< 2, Index > const & | coord | ) |
| inline

CUTLASS_HOST_DEVICE cutlass::MatrixCoord::MatrixCoord | ( | Index | row,
|  | Index | column
| ) |  |
| inline

## Member Function Documentation

CUTLASS_HOST_DEVICE Index const& cutlass::MatrixCoord::column | ( |  | ) | const
| inline

CUTLASS_HOST_DEVICE Index& cutlass::MatrixCoord::column | ( |  | ) |
| inline

CUTLASS_HOST_DEVICE MatrixCoord cutlass::MatrixCoord::operator* | ( | Base const & | b | ) | const
| inline

CUTLASS_HOST_DEVICE MatrixCoord& cutlass::MatrixCoord::operator*= | ( | Base const & | b | ) |
| inline

CUTLASS_HOST_DEVICE MatrixCoord cutlass::MatrixCoord::operator+ | ( | Base const & | b | ) | const
| inline

CUTLASS_HOST_DEVICE MatrixCoord& cutlass::MatrixCoord::operator+= | ( | Base const & | b | ) |
| inline

CUTLASS_HOST_DEVICE MatrixCoord cutlass::MatrixCoord::operator- | ( | Base const & | b | ) | const
| inline

CUTLASS_HOST_DEVICE MatrixCoord& cutlass::MatrixCoord::operator-= | ( | Base const & | b | ) |
| inline

CUTLASS_HOST_DEVICE MatrixCoord cutlass::MatrixCoord::operator/ | ( | Base const & | b | ) | const
| inline

CUTLASS_HOST_DEVICE MatrixCoord& cutlass::MatrixCoord::operator/= | ( | Base const & | b | ) |
| inline

CUTLASS_HOST_DEVICE Index const& cutlass::MatrixCoord::row | ( |  | ) | const
| inline

CUTLASS_HOST_DEVICE Index& cutlass::MatrixCoord::row | ( |  | ) |
| inline

The documentation for this struct was generated from the following file:

- matrix_coord.h